# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

module Line
  module Bot
    module V2
      module ManageAudience
        # Add user IDs or Identifiers for Advertisers (IFAs) to an audience for uploading user IDs (by JSON)
        # @see https://developers.line.biz/en/reference/messaging-api/#update-upload-audience-group
        class AddAudienceToAudienceGroupRequest
          # @!attribute [rw] audience_group_id
          #   @return [Integer,nil] The audience ID.
          attr_accessor :audience_group_id
          # @!attribute [rw] upload_description
          #   @return [String,nil] The audience's name.
          attr_accessor :upload_description
          # @!attribute [rw] audiences
          #   @return [Array[Audience],nil] An array of up to 10,000 user IDs or IFAs.
          attr_accessor :audiences

          # @param audience_group_id [Integer,nil] The audience ID.
          # @param upload_description [String,nil] The audience's name.
          # @param audiences [Array[Audience, Hash[Symbol, untyped]],nil] An array of up to 10,000 user IDs or IFAs.
          def initialize(
            audience_group_id: nil,
            upload_description: nil,
            audiences: nil,
            **dynamic_attributes
          )
            
            @audience_group_id = audience_group_id
            @upload_description = upload_description
            @audiences = audiences&.map do |item|
              if item.is_a?(Hash)
                Line::Bot::V2::ManageAudience::Audience.create(**item) # steep:ignore InsufficientKeywordArguments
              else
                item
              end
            end

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::ManageAudience::AddAudienceToAudienceGroupRequest] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
