# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

module Line
  module Bot
    module V2
      module ManageAudience
        # Audience group
        class AudienceGroup
          # @!attribute [rw] audience_group_id
          #   @return [Integer,nil] The audience ID.
          attr_accessor :audience_group_id
          # @!attribute [rw] type
          #   @return [String,nil] ('UPLOAD'|'CLICK'|'IMP'|'CHAT_TAG'|'FRIEND_PATH'|'RESERVATION'|'APP_EVENT'|'VIDEO_VIEW'|'WEBTRAFFIC'|'IMAGE_CLICK'|'RICHMENU_IMP'|'RICHMENU_CLICK') 
          attr_accessor :type
          # @!attribute [rw] description
          #   @return [String,nil] The audience's name.
          attr_accessor :description
          # @!attribute [rw] status
          #   @return [String,nil] ('IN_PROGRESS'|'READY'|'FAILED'|'EXPIRED'|'INACTIVE'|'ACTIVATING') 
          attr_accessor :status
          # @!attribute [rw] failed_type
          #   @return [String,nil] ('AUDIENCE_GROUP_AUDIENCE_INSUFFICIENT'|'INTERNAL_ERROR'|'') 
          attr_accessor :failed_type
          # @!attribute [rw] audience_count
          #   @return [Integer,nil] The number of users included in the audience.
          attr_accessor :audience_count
          # @!attribute [rw] created
          #   @return [Integer,nil] When the audience was created (in UNIX time).
          attr_accessor :created
          # @!attribute [rw] request_id
          #   @return [String,nil] The request ID that was specified when the audience was created. This is only included when `audienceGroup.type` is CLICK or IMP. 
          attr_accessor :request_id
          # @!attribute [rw] click_url
          #   @return [String,nil] The URL that was specified when the audience was created. This is only included when `audienceGroup.type` is CLICK and link URL is specified. 
          attr_accessor :click_url
          # @!attribute [rw] is_ifa_audience
          #   @return [Boolean,nil] The value indicating the type of account to be sent, as specified when creating the audience for uploading user IDs. 
          attr_accessor :is_ifa_audience
          # @!attribute [rw] permission
          #   @return [String,nil] ('READ'|'READ_WRITE') 
          attr_accessor :permission
          # @!attribute [rw] create_route
          #   @return [String,nil] ('OA_MANAGER'|'MESSAGING_API'|'POINT_AD'|'AD_MANAGER') 
          attr_accessor :create_route

          # @param audience_group_id [Integer,nil] The audience ID.
          # @param type [String,nil] ('UPLOAD'|'CLICK'|'IMP'|'CHAT_TAG'|'FRIEND_PATH'|'RESERVATION'|'APP_EVENT'|'VIDEO_VIEW'|'WEBTRAFFIC'|'IMAGE_CLICK'|'RICHMENU_IMP'|'RICHMENU_CLICK') 
          # @param description [String,nil] The audience's name.
          # @param status [String,nil] ('IN_PROGRESS'|'READY'|'FAILED'|'EXPIRED'|'INACTIVE'|'ACTIVATING') 
          # @param failed_type [String,nil] ('AUDIENCE_GROUP_AUDIENCE_INSUFFICIENT'|'INTERNAL_ERROR'|'') 
          # @param audience_count [Integer,nil] The number of users included in the audience.
          # @param created [Integer,nil] When the audience was created (in UNIX time).
          # @param request_id [String,nil] The request ID that was specified when the audience was created. This is only included when `audienceGroup.type` is CLICK or IMP. 
          # @param click_url [String,nil] The URL that was specified when the audience was created. This is only included when `audienceGroup.type` is CLICK and link URL is specified. 
          # @param is_ifa_audience [Boolean,nil] The value indicating the type of account to be sent, as specified when creating the audience for uploading user IDs. 
          # @param permission [String,nil] ('READ'|'READ_WRITE') 
          # @param create_route [String,nil] ('OA_MANAGER'|'MESSAGING_API'|'POINT_AD'|'AD_MANAGER') 
          def initialize(
            audience_group_id: nil,
            type: nil,
            description: nil,
            status: nil,
            failed_type: nil,
            audience_count: nil,
            created: nil,
            request_id: nil,
            click_url: nil,
            is_ifa_audience: nil,
            permission: nil,
            create_route: nil,
            **dynamic_attributes
          )
            
            @audience_group_id = audience_group_id
            @type = type
            @description = description
            @status = status
            @failed_type = failed_type
            @audience_count = audience_count
            @created = created
            @request_id = request_id
            @click_url = click_url
            @is_ifa_audience = is_ifa_audience
            @permission = permission
            @create_route = create_route

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::ManageAudience::AudienceGroup] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
