# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

require_relative './imagemap_action'

module Line
  module Bot
    module V2
      module MessagingApi
        # @see https://developers.line.biz/en/reference/messaging-api/#imagemap-clipboard-action-object
        class ClipboardImagemapAction < ImagemapAction
          # @!attribute [r] type
          #   @return [String] 
          attr_reader :type
          # @!attribute [rw] area
          #   @return [ImagemapArea] 
          attr_accessor :area
          # @!attribute [rw] clipboard_text
          #   @return [String] Text that is copied to the clipboard. Max character limit: 1000 
          attr_accessor :clipboard_text
          # @!attribute [rw] label
          #   @return [String,nil] 
          attr_accessor :label

          # @param area [ImagemapArea, Hash[Symbol, untyped]] 
          # @param clipboard_text [String] Text that is copied to the clipboard. Max character limit: 1000 
          # @param label [String,nil] 
          def initialize(
            area:,
            clipboard_text:,
            label: nil,
            **dynamic_attributes
          )
            @type = "clipboard"
            
            @area = area.is_a?(Line::Bot::V2::MessagingApi::ImagemapArea) ? area : Line::Bot::V2::MessagingApi::ImagemapArea.create(**area) # steep:ignore
            @clipboard_text = clipboard_text
            @label = label

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::MessagingApi::ClipboardImagemapAction] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
