# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

require_relative './flex_component'

module Line
  module Bot
    module V2
      module MessagingApi
        class FlexText < FlexComponent
          # @!attribute [r] type
          #   @return [String] 
          attr_reader :type
          # @!attribute [rw] flex
          #   @return [Integer,nil] 
          attr_accessor :flex
          # @!attribute [rw] text
          #   @return [String,nil] 
          attr_accessor :text
          # @!attribute [rw] size
          #   @return [String,nil] 
          attr_accessor :size
          # @!attribute [rw] align
          #   @return [String,nil] ('start'|'end'|'center') 
          attr_accessor :align
          # @!attribute [rw] gravity
          #   @return [String,nil] ('top'|'bottom'|'center') 
          attr_accessor :gravity
          # @!attribute [rw] color
          #   @return [String,nil] 
          attr_accessor :color
          # @!attribute [rw] weight
          #   @return [String,nil] ('regular'|'bold') 
          attr_accessor :weight
          # @!attribute [rw] style
          #   @return [String,nil] ('normal'|'italic') 
          attr_accessor :style
          # @!attribute [rw] decoration
          #   @return [String,nil] ('none'|'underline'|'line-through') 
          attr_accessor :decoration
          # @!attribute [rw] wrap
          #   @return [Boolean,nil] 
          attr_accessor :wrap
          # @!attribute [rw] line_spacing
          #   @return [String,nil] 
          attr_accessor :line_spacing
          # @!attribute [rw] margin
          #   @return [String,nil] 
          attr_accessor :margin
          # @!attribute [rw] position
          #   @return [String,nil] ('relative'|'absolute') 
          attr_accessor :position
          # @!attribute [rw] offset_top
          #   @return [String,nil] 
          attr_accessor :offset_top
          # @!attribute [rw] offset_bottom
          #   @return [String,nil] 
          attr_accessor :offset_bottom
          # @!attribute [rw] offset_start
          #   @return [String,nil] 
          attr_accessor :offset_start
          # @!attribute [rw] offset_end
          #   @return [String,nil] 
          attr_accessor :offset_end
          # @!attribute [rw] action
          #   @return [Action,nil] 
          attr_accessor :action
          # @!attribute [rw] max_lines
          #   @return [Integer,nil] 
          attr_accessor :max_lines
          # @!attribute [rw] contents
          #   @return [Array[FlexSpan],nil] 
          attr_accessor :contents
          # @!attribute [rw] adjust_mode
          #   @return [String,nil] ('shrink-to-fit') 
          attr_accessor :adjust_mode
          # @!attribute [rw] scaling
          #   @return [Boolean,nil] 
          attr_accessor :scaling

          # @param flex [Integer,nil] 
          # @param text [String,nil] 
          # @param size [String,nil] 
          # @param align [String,nil] ('start'|'end'|'center') 
          # @param gravity [String,nil] ('top'|'bottom'|'center') 
          # @param color [String,nil] 
          # @param weight [String,nil] ('regular'|'bold') 
          # @param style [String,nil] ('normal'|'italic') 
          # @param decoration [String,nil] ('none'|'underline'|'line-through') 
          # @param wrap [Boolean,nil] 
          # @param line_spacing [String,nil] 
          # @param margin [String,nil] 
          # @param position [String,nil] ('relative'|'absolute') 
          # @param offset_top [String,nil] 
          # @param offset_bottom [String,nil] 
          # @param offset_start [String,nil] 
          # @param offset_end [String,nil] 
          # @param action [Action, Hash[Symbol, untyped], nil] 
          # @param max_lines [Integer,nil] 
          # @param contents [Array[FlexSpan, Hash[Symbol, untyped]],nil] 
          # @param adjust_mode [String,nil] ('shrink-to-fit') 
          # @param scaling [Boolean,nil] 
          def initialize(
            flex: nil,
            text: nil,
            size: nil,
            align: nil,
            gravity: nil,
            color: nil,
            weight: nil,
            style: nil,
            decoration: nil,
            wrap: nil,
            line_spacing: nil,
            margin: nil,
            position: nil,
            offset_top: nil,
            offset_bottom: nil,
            offset_start: nil,
            offset_end: nil,
            action: nil,
            max_lines: nil,
            contents: nil,
            adjust_mode: nil,
            scaling: nil,
            **dynamic_attributes
          )
            @type = "text"
            
            @flex = flex
            @text = text
            @size = size
            @align = align
            @gravity = gravity
            @color = color
            @weight = weight
            @style = style
            @decoration = decoration
            @wrap = wrap
            @line_spacing = line_spacing
            @margin = margin
            @position = position
            @offset_top = offset_top
            @offset_bottom = offset_bottom
            @offset_start = offset_start
            @offset_end = offset_end
            @action = action.is_a?(Line::Bot::V2::MessagingApi::Action) || action.nil? ? action : Line::Bot::V2::MessagingApi::Action.create(**action) # steep:ignore
            @max_lines = max_lines
            @contents = contents&.map do |item|
              if item.is_a?(Hash)
                Line::Bot::V2::MessagingApi::FlexSpan.create(**item) # steep:ignore InsufficientKeywordArguments
              else
                item
              end
            end
            @adjust_mode = adjust_mode
            @scaling = scaling

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::MessagingApi::FlexText] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
