# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

require_relative './substitution_object'

module Line
  module Bot
    module V2
      module MessagingApi
        # An object representing a mention substitution.
        # @see https://developers.line.biz/en/reference/messaging-api/#text-message-v2-mention-object
        class MentionSubstitutionObject < SubstitutionObject
          # @!attribute [r] type
          #   @return [String] Type of substitution object
          attr_reader :type
          # @!attribute [rw] mentionee
          #   @return [MentionTarget] 
          attr_accessor :mentionee

          # @param mentionee [MentionTarget, Hash[Symbol, untyped]] 
          def initialize(
            mentionee:,
            **dynamic_attributes
          )
            @type = "mention"
            
            @mentionee = mentionee.is_a?(Line::Bot::V2::MessagingApi::MentionTarget) ? mentionee : Line::Bot::V2::MessagingApi::MentionTarget.create(**mentionee) # steep:ignore

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::MessagingApi::MentionSubstitutionObject] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
