# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

require_relative './recipient'

module Line
  module Bot
    module V2
      module MessagingApi
        class OperatorRecipient < Recipient
          # @!attribute [r] type
          #   @return [String,nil] Type of recipient
          attr_reader :type
          # @!attribute [rw] _and
          #   @return [Array[Recipient],nil] Create a new recipient object by taking the logical conjunction (AND) of the specified array of recipient objects. 
          attr_accessor :_and
          # @!attribute [rw] _or
          #   @return [Array[Recipient],nil] Create a new recipient object by taking the logical disjunction (OR) of the specified array of recipient objects. 
          attr_accessor :_or
          # @!attribute [rw] _not
          #   @return [Recipient,nil] 
          attr_accessor :_not

          # @param _and [Array[Recipient, Hash[Symbol, untyped]],nil] Create a new recipient object by taking the logical conjunction (AND) of the specified array of recipient objects. 
          # @param _or [Array[Recipient, Hash[Symbol, untyped]],nil] Create a new recipient object by taking the logical disjunction (OR) of the specified array of recipient objects. 
          # @param _not [Recipient, Hash[Symbol, untyped], nil] 
          def initialize(
            _and: nil,
            _or: nil,
            _not: nil,
            **dynamic_attributes
          )
            @type = "operator"
            
            @_and = _and&.map do |item|
              if item.is_a?(Hash)
                Line::Bot::V2::MessagingApi::Recipient.create(**item) # steep:ignore InsufficientKeywordArguments
              else
                item
              end
            end
            @_or = _or&.map do |item|
              if item.is_a?(Hash)
                Line::Bot::V2::MessagingApi::Recipient.create(**item) # steep:ignore InsufficientKeywordArguments
              else
                item
              end
            end
            @_not = _not.is_a?(Line::Bot::V2::MessagingApi::Recipient) || _not.nil? ? _not : Line::Bot::V2::MessagingApi::Recipient.create(**_not) # steep:ignore

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::MessagingApi::OperatorRecipient] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
