# LINE Messaging API
# This document describes LINE Messaging API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

module Line
  module Bot
    module V2
      module MessagingApi
        # Object containing user membership subscription information.
        class SubscribedMembershipUser
          # @!attribute [rw] membership_no
          #   @return [Integer] The user's member number in the membership plan.
          attr_accessor :membership_no
          # @!attribute [rw] joined_time
          #   @return [Integer] UNIX timestamp at which the user subscribed to the membership.
          attr_accessor :joined_time
          # @!attribute [rw] next_billing_date
          #   @return [String] Next payment date for membership plan. - Format: yyyy-MM-dd (e.g. 2024-02-08) - Timezone: UTC+9 
          attr_accessor :next_billing_date
          # @!attribute [rw] total_subscription_months
          #   @return [Integer] The period of time in months that the user has been subscribed to a membership plan. If a user previously canceled and then re-subscribed to the same membership plan, only the period after the re-subscription will be counted.
          attr_accessor :total_subscription_months

          # @param membership_no [Integer] The user's member number in the membership plan.
          # @param joined_time [Integer] UNIX timestamp at which the user subscribed to the membership.
          # @param next_billing_date [String] Next payment date for membership plan. - Format: yyyy-MM-dd (e.g. 2024-02-08) - Timezone: UTC+9 
          # @param total_subscription_months [Integer] The period of time in months that the user has been subscribed to a membership plan. If a user previously canceled and then re-subscribed to the same membership plan, only the period after the re-subscription will be counted.
          def initialize(
            membership_no:,
            joined_time:,
            next_billing_date:,
            total_subscription_months:,
            **dynamic_attributes
          )
            
            @membership_no = membership_no
            @joined_time = joined_time
            @next_billing_date = next_billing_date
            @total_subscription_months = total_subscription_months

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::MessagingApi::SubscribedMembershipUser] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
