# Mission Stickers API
# This document describes LINE Mission Stickers API.
#
# The version of the OpenAPI document: 0.0.1
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

module Line
  module Bot
    module V2
      module Shop
        # Send mission stickers (v3)
        # @see https://developers.line.biz/en/reference/partner-docs/#send-mission-stickers-v3
        class MissionStickerRequest
          # @!attribute [rw] to
          #   @return [String] Destination user ID
          attr_accessor :to
          # @!attribute [rw] product_id
          #   @return [String] Package ID for a set of stickers
          attr_accessor :product_id
          # @!attribute [rw] product_type
          #   @return [String] `STICKER`
          attr_accessor :product_type
          # @!attribute [rw] send_present_message
          #   @return [Boolean] `false`
          attr_accessor :send_present_message

          # @param to [String] Destination user ID
          # @param product_id [String] Package ID for a set of stickers
          # @param product_type [String] `STICKER`
          # @param send_present_message [Boolean] `false`
          def initialize(
            to:,
            product_id:,
            product_type:,
            send_present_message:,
            **dynamic_attributes
          )
            
            @to = to
            @product_id = product_id
            @product_type = product_type
            @send_present_message = send_present_message

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::Shop::MissionStickerRequest] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
