# Webhook Type Definition
# Webhook event definition of the LINE Messaging API
#
# The version of the OpenAPI document: 1.0.0
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

require_relative './module_content'

module Line
  module Bot
    module V2
      module Webhook
        class AttachedModuleContent < ModuleContent
          # @!attribute [r] type
          #   @return [String] Type
          attr_reader :type
          # @!attribute [rw] bot_id
          #   @return [String] User ID of the bot on the attached LINE Official Account
          attr_accessor :bot_id
          # @!attribute [rw] scopes
          #   @return [Array[String]] An array of strings indicating the scope permitted by the admin of the LINE Official Account.
          attr_accessor :scopes

          # @param bot_id [String] User ID of the bot on the attached LINE Official Account
          # @param scopes [Array[String]] An array of strings indicating the scope permitted by the admin of the LINE Official Account.
          def initialize(
            bot_id:,
            scopes:,
            **dynamic_attributes
          )
            @type = "attached"
            
            @bot_id = bot_id
            @scopes = scopes

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::Webhook::AttachedModuleContent] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
