# Webhook Type Definition
# Webhook event definition of the LINE Messaging API
#
# The version of the OpenAPI document: 1.0.0
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

module Line
  module Bot
    module V2
      module Webhook
        # Provider of the media file.
        class ContentProvider
          # @!attribute [rw] type
          #   @return [String] ('line'|'external') Provider of the image file.
          attr_accessor :type
          # @!attribute [rw] original_content_url
          #   @return [String,nil] URL of the image file. Only included when contentProvider.type is external.
          attr_accessor :original_content_url
          # @!attribute [rw] preview_image_url
          #   @return [String,nil] URL of the preview image. Only included when contentProvider.type is external.
          attr_accessor :preview_image_url

          # @param type [String] ('line'|'external') Provider of the image file.
          # @param original_content_url [String,nil] URL of the image file. Only included when contentProvider.type is external.
          # @param preview_image_url [String,nil] URL of the preview image. Only included when contentProvider.type is external.
          def initialize(
            type:,
            original_content_url: nil,
            preview_image_url: nil,
            **dynamic_attributes
          )
            
            @type = type
            @original_content_url = original_content_url
            @preview_image_url = preview_image_url

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::Webhook::ContentProvider] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
