# Webhook Type Definition
# Webhook event definition of the LINE Messaging API
#
# The version of the OpenAPI document: 1.0.0
#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

require_relative './mentionee'

module Line
  module Bot
    module V2
      module Webhook
        # Mentioned target is user
        class UserMentionee < Mentionee
          # @!attribute [r] type
          #   @return [String] Mentioned target.
          attr_reader :type
          # @!attribute [rw] index
          #   @return [Integer] Index position of the user mention for a character in text, with the first character being at position 0.
          attr_accessor :index
          # @!attribute [rw] length
          #   @return [Integer] The length of the text of the mentioned user. For a mention @example, 8 is the length.
          attr_accessor :length
          # @!attribute [rw] user_id
          #   @return [String,nil] User ID of the mentioned user. Only included if mention.mentions[].type is user and the user consents to the LINE Official Account obtaining their user profile information.
          attr_accessor :user_id
          # @!attribute [rw] is_self
          #   @return [Boolean,nil] Whether the mentioned user is the bot that receives the webhook.
          attr_accessor :is_self

          # @param index [Integer] Index position of the user mention for a character in text, with the first character being at position 0.
          # @param length [Integer] The length of the text of the mentioned user. For a mention @example, 8 is the length.
          # @param user_id [String,nil] User ID of the mentioned user. Only included if mention.mentions[].type is user and the user consents to the LINE Official Account obtaining their user profile information.
          # @param is_self [Boolean,nil] Whether the mentioned user is the bot that receives the webhook.
          def initialize(
            index:,
            length:,
            user_id: nil,
            is_self: nil,
            **dynamic_attributes
          )
            @type = "user"
            
            @index = index
            @length = length
            @user_id = user_id
            @is_self = is_self

            dynamic_attributes.each do |key, value|
              self.class.attr_accessor key

              if value.is_a?(Hash)
                struct_klass = Struct.new(*value.keys.map(&:to_sym))
                struct_values = value.map { |_k, v| v.is_a?(Hash) ? Line::Bot::V2::Utils.hash_to_struct(v) : v }
                instance_variable_set("@#{key}", struct_klass.new(*struct_values))
              else
                instance_variable_set("@#{key}", value)
              end
            end
          end

          # Create an instance of the class from a hash
          # @param args [Hash] Hash containing all the required attributes
          # @return [Line::Bot::V2::Webhook::UserMentionee] Instance of the class
          def self.create(args) # steep:ignore
            symbolized_args = Line::Bot::V2::Utils.deep_symbolize(args)
            return new(**symbolized_args) # steep:ignore
          end

          # @param other [Object] Object to compare
          # @return [Boolean] true if the objects are equal, false otherwise
          def ==(other)
            return false unless self.class == other.class

            instance_variables.all? do |var|
                instance_variable_get(var) == other.instance_variable_get(var)
            end
          end

          # @return [Integer] Hash code of the object
          def hash
            [self.class, *instance_variables.map { |var| instance_variable_get(var) }].hash
          end
        end
      end
    end
  end
end
